#include <bits/stdc++.h>
#include <experimental/random>
#include <immintrin.h>
#pragma GCC target("avx,avx2")
using namespace std;
using ll = long long;
void solve();
int main() {
    ll q = 1;
    while (q--) {
        solve();
    }
}
ll h, w, q;
vector<vector<ll>> a;
pair<bool, string> prov(vector<ll>& el) {
    ll n = h / 2;
    unordered_map<ll, ll> fir;
    for (int i = 0; i < (1 << n); i++) {
        ll sum = 0;
        for (int j = 0; j < n; j++) {
            if (((i >> j) & 1) == 0) {
                sum += el[j];
            }
        }
        fir[sum] = i;
    }
    ll n2 = h - n;
    for (int i = 0; i < (1 << n2); i++) {
        ll sum = 0;
        for (int j = 0; j < n2; j++) {
            if (((i >> j) & 1) == 0) {
                sum += el[j + n];
            }
        }
        ll x = q - sum;
        auto it = fir.find(x);
        if (it != fir.end()) {
            string ans;
            for (int j = 0; j < n; j++) {
                ans += to_string(((it->second >> j) & 1));
            }
            for (int j = 0; j < n2; j++) {
                ans += to_string((i >> j) & 1);
            }
            return {true, ans};
        }
    }
    return {false, ""};
}
void solve() {
    cin >> h >> w;
    a.resize(h, vector<ll>(w));
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            cin >> a[i][j];
        }
    }
    cin >> q;
    for (int i = 0; i < (1 << w); i++) {
        vector<ll> el;
        for (int k = 0; k < h; k++) {
            ll cnt = 0;
            for (int j = 0; j < w; j++) {
                if (((i >> j) & 1) ==  0) {
                    cnt += a[k][j];
                }
            }
            el.push_back(cnt);
        }
        pair<bool, string> f = prov(el);
        if (f.first) {
            ll cnt = 0;
            for (int j = 0; j < w; j++) {
                if (((i >> j) & 1) == 1) {
                    cnt++;
                }
            }
            for (auto c : f.second) {
                if (c == '1') {
                    cnt++;
                }
            }
            cout << "YES" << endl << cnt << endl;
            for (int c = 0; c < h; c++) {
                if (f.second[c] == '1') {
                    cout << 1 << ' ' << c + 1 << endl;
                }
            }
            for (int c = 0; c < w; c++) {
                if (((i >> c) & 1) == 1) {
                    cout << 2 << ' ' << c + 1 << endl;
                }
            }
            return;
        }
    }
    cout << "NO";
}
