#include <bits/stdc++.h>
#include <experimental/random>
using ll = long long;
using namespace std;

void solve();

int main() {
    int q = 1;
    while (q--) {
        solve();
    }
}
struct st {
    ll l, r, x;
    st() {
        l = -1, r = -1, x = -1;
    }
};
vector<st> g;
vector<ll> z;
vector<ll> ind;
vector<ll> dp;
void dfs(ll v) {
    if (g[v].l == -1 && g[v].r == -1) {
        z.push_back(v);
        dp[v] = 1;
        ind[v] = (int)z.size();
        return;
    }
    if (g[v].x == -1) {
        z.push_back(v);
        ind[v] = (int)z.size();
        if (g[v].l != -1) {
            dfs(g[v].l);
        }
        if (g[v].r != -1) {
            dfs(g[v].r);
        }
        dp[v] += dp[g[v].l] + dp[g[v].r];
    }
    if (g[v].x == 0) {
        if (g[v].l != -1) {
            dfs(g[v].l);
        }
        z.push_back(v);
        ind[v] = (int)z.size();
        if (g[v].r != -1) {
            dfs(g[v].r);
        }
        dp[v] += dp[g[v].l] + dp[g[v].r];
    }
    if (g[v].x == 1) {
        if (g[v].l != -1) {
            dfs(g[v].l);
        }
        if (g[v].r != -1) {
            dfs(g[v].r);
        }
        z.push_back(v);
        ind[v] = (int)z.size();
        dp[v] += dp[g[v].l] + dp[g[v].r];
    }
}
void solve() {
    ll n, q;
    cin >> n >> q;
    g.resize(n);
    ind.resize(n);
    dp.resize(n);
    for (int i = 0; i < n; i++) {
        ll l, r;
        cin >> l >> r;
        if (l != 0) {
            g[i].l = l - 1;
        }
        if (r != 0) {
            g[i].r = r - 1;
        }
    }
    dfs(0);
    while (q--) {
        ll t;
        cin >> t;
        if (t == 1) {
            ll l, r, x;
            cin >> l >> r >> x;
            l--, r--;
            if (l == r) {
                if (x == -1) {
                    if (g[l].x == 0) {
                        ind[l] -= dp[g[l].l];
                    }
                    if (g[l].x == 1) {
                        ind[l] -= dp[g[l].l] - dp[g[l].r];
                    }
                } else if (x == 0) {
                    if (g[l].x == -1) {
                        ind[l] += dp[g[l].l];
                    }
                    if (g[l].x == 1) {
                        ind[l] -= dp[g[l].r];
                    }
                } else {
                    if (g[l].x == -1) {
                        ind[l] += dp[g[l].l] + dp[g[l].r];
                    }
                    if (g[l].x == 0) {
                        ind[l] += dp[g[l].r];
                    }
                }
            }
            z.clear();
            for (int i = l; i <= r; i++) {
                g[i].x = x;
            }
            if (l != r) {
                dfs(0);
            }
        }  else {
            ll i;
            cin >> i;
            cout << ind[i - 1] << '\n';
        }
    }
}
