#include <bits/stdc++.h>
#include <experimental/random>
using ll = long long;
using namespace std;

void solve();

int main() {
    ll q = 1;
    while (q--) {
        solve();
    }
}
vector<vector<ll>> g;
vector<ll> used, ans;
void dfs(ll v, ll color) {
    ans[v] = color;
    used[v] = 1;
    for (auto u : g[v]) {
        if (used[u] == 0) {
            if (color == 1) {
                dfs(u, 2);
            } else {
                dfs(u, 1);
            }
        }
    }
}
void solve() {
    ll n;
    cin >> n;
    g.resize(n);
    used.resize(n);
    ans.resize(n);
    vector<ll> a(n);
    map<ll, vector<ll>> ind;
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        ind[a[i]].push_back(i);
    }
    set<ll> del;
    vector<ll> er(1e6 + 1);
    for (ll i = 2; i <= 1e6; i++) {
        if (er[i] == 0) {
            del.insert(i);
            for (ll j = i * i; j <= 1e6; j += i) {
                er[j] = 1;
            }
        }
    }
    for (ll i = 0; i < n; i++) {
        for (ll d = 1; d * d <= a[i]; d++) {
            if (a[i] % d != 0) {
                continue;
            }
            if (ind.find(d) != ind.end() && del.find(a[i] / d) != del.end()) {
                for (auto j : ind[d]) {
                    g[i].push_back(j);
                    g[j].push_back(i);
                }
            }
            ll d2 = a[i] / d;
            if (d == d2) {
                continue;
            }
            if (ind.find(d2) == ind.end() || del.find(a[i] / d2) == del.end()) {
                continue;
            }
            for (auto j : ind[d2]) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    for (ll i = 0; i < n; i++) {
        if (used[i] == 0) {
            dfs(i, 1);
        }
    }
    for (auto i : ans) {
        cout << i << ' ';
    }
}
