#include <bits/stdc++.h>
#include <experimental/random>
using ll = long long;
using namespace std;

void solve();

int main() {
    int q = 1;
    while (q--) {
        solve();
    }
}
struct st {
    ll l, r, x;
    st() {
        l = -1, r = -1, x = -1;
    }
};
vector<st> g;
vector<ll> z;
vector<ll> ind;
vector<ll> dp;
vector<pair<ll, ll>> tree;
ll n;
void push(ll v, ll vl, ll vr) {
    if (tree[v].second == -2) {
        return;
    }
    tree[v].first = tree[v].second;
    if (vr - vl != 1) {
        tree[2 * v].second = tree[v].second;
        tree[2 * v + 1].second = tree[v].second;
    }
    tree[v].second = -2;
}
void change(ll v, ll vl, ll vr, ll l, ll r, ll x) {
    if (vl >= r || vr <= l) {
        push(v, vl, vr);
        return;
    }
    if (vl >= l && vr <= r) {
        tree[v].second = x;
        push(v, vl, vr);
        return;
    }
    push(v, vl, vr);
    change(2 * v, vl, (vl + vr) / 2, l, r, x);
    change(2 * v + 1, (vl + vr) / 2, vr, l, r, x);
}
ll get(ll v, ll vl, ll vr, ll pos) {
    push(v, vl, vr);
    if (vr - vl == 1) {
        return tree[v].first;
    }
    ll mid = (vl + vr) / 2;
    if (pos < mid) {
        return get(2 * v, vl, mid, pos);
    } else {
        return get(2 * v + 1, mid, vr, pos);
    }
}
bool fl = true;
void dfs(ll v) {
    if (fl) {
        g[v].x = get(1, 0, n, v);
    }
    if (g[v].l == -1 && g[v].r == -1) {
        z.push_back(v);
        dp[v] = 1;
        ind[v] = (int)z.size();
        return;
    }
    if (g[v].x == -1) {
        z.push_back(v);
        ind[v] = (int)z.size();
        if (g[v].l != -1) {
            dfs(g[v].l);
        }
        if (g[v].r != -1) {
            dfs(g[v].r);
        }
        dp[v] += dp[g[v].l] + dp[g[v].r];
    }
    if (g[v].x == 0) {
        if (g[v].l != -1) {
            dfs(g[v].l);
        }
        z.push_back(v);
        ind[v] = (int)z.size();
        if (g[v].r != -1) {
            dfs(g[v].r);
        }
        dp[v] += dp[g[v].l] + dp[g[v].r];
    }
    if (g[v].x == 1) {
        if (g[v].l != -1) {
            dfs(g[v].l);
        }
        if (g[v].r != -1) {
            dfs(g[v].r);
        }
        z.push_back(v);
        ind[v] = (int)z.size();
        dp[v] += dp[g[v].l] + dp[g[v].r];
    }
}
struct qs {
    ll t, l, r, x;
};
void solve() {
    ll q;
    cin >> n >> q;
    g.resize(n);
    ind.resize(n);
    dp.resize(n);
    for (int i = 0; i < n; i++) {
        ll l, r;
        cin >> l >> r;
        if (l != 0) {
            g[i].l = l - 1;
        }
        if (r != 0) {
            g[i].r = r - 1;
        }
    }
    vector<qs> s;
    bool f = false ;
    while (q--) {
        ll t;
        cin >> t;
        if (t == 1) {
            ll l, r, x;
            cin >> l >> r >> x;
            s.push_back({t, l, r, x});
            if (f) {
                fl = false;
            }
        } else {
            ll i;
            cin >> i;
            s.push_back({t, i, -1, -1});
            f = true;
        }
    }
    tree.resize(4 * n, {-1, -2});
    bool ful = false;
    if (fl) {
        for (auto [t, l, r, x] : s) {
            if (t == 1) {
                change(1, 0, n, l - 1, r, x);
            }  else {
                if (!ful) {
                    dfs(0);
                    ful = true;
                }
                ll i = l;
                cout << ind[i - 1] << endl;
            }
        }
        return;
    }
    dfs(0);
    for (auto [t, l, r, x] : s) {
        if (t == 1) {
            l--, r--;
            z.clear();
            for (int i = l; i <= r; i++) {
                g[i].x = x;
            }
            dfs(0);
        }  else {
            ll i = l;
            cout << ind[i - 1] << endl;
        }
    }
}
